/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EchocardiographyAorticValve;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EchocardiographyCommonMeasurements;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_OrificeFlowProperties;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_EchocardiographyAorticValve;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents EchocardiographyAorticValve CID12211
 */
public class EchocardiographyAorticValve_CID12211 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	/**
	 * Object of EchocardiographyCommonMeasurements_CID12220
	 */
	private EchocardiographyCommonMeasurements_CID12220 objEchocardiographyCommonMeasurementsCID12220;
	/**
	 * Object of OrificeFlowProperties_CID12222
	 */
	private OrificeFlowProperties_CID12222 objOrificeFlowPropertiesCID12222;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new EchocardiographyAorticValve_CID12211 Template 
	 */
	public EchocardiographyAorticValve_CID12211()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumEchocardiographyAorticValve Object of EnumCM_EchocardiographyAorticValve represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_EchocardiographyAorticValve enumEchocardiographyAorticValve)
	{
		switch(enumEchocardiographyAorticValve)
		{
		case AORTIC_VALVE_CUSP_SEPARATION: this.strCodeValue =EnumCV_EchocardiographyAorticValve.AORTIC_VALVE_CUSP_SEPARATION_17996_0.getValue(); break;
		case AORTIC_VALVE_EJECTION_TIME: this.strCodeValue =EnumCV_EchocardiographyAorticValve.AORTIC_VALVE_EJECTION_TIME_18041_4.getValue(); break;
		case RATIO_OF_AORTIC_VALVE_ACCELERATION_TIME_TO_EJECTION_TIME: this.strCodeValue =EnumCV_EchocardiographyAorticValve.RATIO_OF_AORTIC_VALVE_ACCELERATION_TIME_TO_EJECTION_TIME_G_0382.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumEchocardiographyAorticValve Object of EnumCM_EchocardiographyAorticValve represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_EchocardiographyAorticValve enumEchocardiographyAorticValve)
	{
		switch(enumEchocardiographyAorticValve)
		{
		case RATIO_OF_AORTIC_VALVE_ACCELERATION_TIME_TO_EJECTION_TIME : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.RATIO_OF_AORTIC_VALVE_ACCELERATION_TIME_TO_EJECTION_TIME.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for EchocardiographyAorticValve
	 * @param enumEchocardiographyAorticValve Object of EnumCM_EchocardiographyAorticValve.
	 */
	public void setEchocardiographyAorticValve(Enum enumValue)
	{
		if(enumValue instanceof EnumCM_EchocardiographyAorticValve)
		{
			 /**
				 * Casting EnumValue to required Enum.
				 */
			EnumCM_EchocardiographyAorticValve new_enumEchocardiographyAorticValve = (EnumCM_EchocardiographyAorticValve)enumValue;
				
				this.strCodeMeaning = new_enumEchocardiographyAorticValve.getValue();
				if(new_enumEchocardiographyAorticValve.getValue().equalsIgnoreCase(EnumCM_EchocardiographyAorticValve.RATIO_OF_AORTIC_VALVE_ACCELERATION_TIME_TO_EJECTION_TIME.getValue()))
				{
					this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
				}
				else
				{
					this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
				}
				
				/**
				 * set code Value
				 */
				setCodeValue(new_enumEchocardiographyAorticValve);
				/**
				 * set SNOMED-CT ID
				 */
				setSNOMEDCTID(new_enumEchocardiographyAorticValve);

		}
		 else if(enumValue instanceof EnumCM_EchocardiographyCommonMeasurements)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_EchocardiographyCommonMeasurements new_enumEchocardiographyCommonMeasurements = (EnumCM_EchocardiographyCommonMeasurements) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objEchocardiographyCommonMeasurementsCID12220)
				this.objEchocardiographyCommonMeasurementsCID12220 = new EchocardiographyCommonMeasurements_CID12220();
				this.objEchocardiographyCommonMeasurementsCID12220.setEchocardiographyCommonMeasurements(new_enumEchocardiographyCommonMeasurements);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objEchocardiographyCommonMeasurementsCID12220.getCodeMeaning();
				this.strCodeValue = objEchocardiographyCommonMeasurementsCID12220.getCodeValue();
				this.strCodingSchemeDesignator = objEchocardiographyCommonMeasurementsCID12220.getCodingSchemeDesignator();
			}
		 else if(enumValue instanceof EnumCM_OrificeFlowProperties)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_OrificeFlowProperties new_enumOrificeFlowProperties = (EnumCM_OrificeFlowProperties) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objOrificeFlowPropertiesCID12222)
				this.objOrificeFlowPropertiesCID12222 = new OrificeFlowProperties_CID12222();
				this.objOrificeFlowPropertiesCID12222.setOrificeFlowProperties(new_enumOrificeFlowProperties);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objOrificeFlowPropertiesCID12222.getCodeMeaning();
				this.strCodeValue = objOrificeFlowPropertiesCID12222.getCodeValue();
				this.strCodingSchemeDesignator = objOrificeFlowPropertiesCID12222.getCodingSchemeDesignator();
			}
		 
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
				objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
	}
}
